using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace DataRelationExample
{
    class Program
    {
        static void Main(string[] args)
        {
            DataTable JednostkaTable = new DataTable("Jednostka");

            JednostkaTable.Columns.Add("ID", Type.GetType("System.Int32"));
            JednostkaTable.Columns.Add("Nazwa", Type.GetType("System.String"));

            JednostkaTable.PrimaryKey = new DataColumn[] { JednostkaTable.Columns["ID"] };

            JednostkaTable.Columns["ID"].AutoIncrement = true;
            JednostkaTable.Columns["ID"].AutoIncrementSeed = 1;
            JednostkaTable.Columns["ID"].ReadOnly = true;

            JednostkaTable.Rows.Add(1, "Wrocaw");
            JednostkaTable.Rows.Add(2, "Warszawa");
            JednostkaTable.Rows.Add(3, "Krakw");


            DataTable OsobaTable = new DataTable("Osoba");

            OsobaTable.Columns.Add("ID", Type.GetType("System.Int32"));
            OsobaTable.Columns.Add("ID_Jednostka", Type.GetType("System.Int32"));
            OsobaTable.Columns.Add("Nazwa_Jednostka", Type.GetType("System.String"));
            OsobaTable.Columns.Add("Nazwisko", Type.GetType("System.String"));
            OsobaTable.Columns.Add("Imie", Type.GetType("System.String"));

            OsobaTable.PrimaryKey = new DataColumn[] { OsobaTable.Columns["ID"] };

            OsobaTable.Columns["ID"].AutoIncrement = true;
            OsobaTable.Columns["ID"].AutoIncrementSeed = 1;
            OsobaTable.Columns["ID"].ReadOnly = true;

            OsobaTable.Rows.Add(1, 1, "Wrocaw", "Kowalski", "Jan");
            OsobaTable.Rows.Add(2, 3, "Krakw", "Nowak", "Elbieta");
            OsobaTable.Rows.Add(3, 2, "Warszawa", "Malinowski", "Marek");
            OsobaTable.Rows.Add(4, 1, "Wrocaw", "Smith", "John");

            DataSet ds = new DataSet("DaneOsobowe");
            ds.Tables.Add(JednostkaTable);
            ds.Tables.Add(OsobaTable);
            //ds.Relations.Add("Jednostka_Osoba", JednostkaTable.Columns["ID"], OsobaTable.Columns["ID_Jednostka"]);

            DataRelation jednostka_osoba = new DataRelation(
                "Jednostka_Osoba",
                new DataColumn[] { ds.Tables["Jednostka"].Columns["ID"], JednostkaTable.Columns["Nazwa"] },
                new DataColumn[] { ds.Tables["Osoba"].Columns["ID_Jednostka"], OsobaTable.Columns["Nazwa_Jednostka"] }
                );
            
            ds.Relations.Add(jednostka_osoba);

            Console.ReadLine();
        }
    }
}
