using System;
using System.Collections.Generic;
using System.Text;
using System.Data;

namespace DataTableExample
{
    class Program
    {
        static void Main(string[] args)
        {
            DataTable OsobaTable = new DataTable("Osoba");

            OsobaTable.Columns.Add("ID", Type.GetType("System.Int32"));
            OsobaTable.Columns.Add("Nazwisko", Type.GetType("System.String"));
            OsobaTable.Columns.Add("Imie", Type.GetType("System.String"));
            OsobaTable.Columns.Add("DataUrodzenia", Type.GetType("System.DateTime"));

            OsobaTable.PrimaryKey = new DataColumn[] { OsobaTable.Columns["ID"] };

            OsobaTable.Columns["ID"].AutoIncrement = true;
            OsobaTable.Columns["ID"].AutoIncrementSeed = 1;
            OsobaTable.Columns["ID"].ReadOnly = true;

            OsobaTable.Rows.Add(1, "Kowalski", "Jan"); // tutaj ID by musi
            DataRow row = OsobaTable.NewRow();
            //row["ID"] = 2; // moemy poda, ale nie musimy
            row["Nazwisko"] = "Nowak";
            row["Imie"] = "Elzbieta";
            OsobaTable.Rows.Add(row);

            //OsobaTable.Rows[1]["ID"] = 3; // to si wywali

            foreach (DataRow r in OsobaTable.Rows)
            {
                foreach (DataColumn c in OsobaTable.Columns)
                    Console.Write(r[c] + "\t");
                Console.WriteLine();
            }
            Console.ReadLine();
        }
    }
}
