using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DataTableExample2
{
    public partial class frmOsoby : Form
    {
        public frmOsoby()
        {
            InitializeComponent();
            gridOsoby.DataSource = GetDataTable();
        }


        private DataTable GetDataTable()
        {
            DataTable OsobaTable = new DataTable("Osoba");

            OsobaTable.Columns.Add("ID", Type.GetType("System.Int32"));
            OsobaTable.Columns.Add("Nazwisko", Type.GetType("System.String"));
            OsobaTable.Columns.Add("Imie", Type.GetType("System.String"));
            OsobaTable.Columns.Add("DataUrodzenia", Type.GetType("System.DateTime"));

            OsobaTable.PrimaryKey = new DataColumn[] { OsobaTable.Columns["ID"] };

            OsobaTable.Columns["ID"].AutoIncrement = true;
            OsobaTable.Columns["ID"].AutoIncrementSeed = 1;
            //OsobaTable.Columns["ID"].ReadOnly = true;

            OsobaTable.Rows.Add(1, "Kowalski", "Jan"); // tutaj ID by musi
            DataRow row = OsobaTable.NewRow();
            row["Nazwisko"] = "Nowak";
            row["Imie"] = "Elzbieta";
            OsobaTable.Rows.Add(row);

            OsobaTable.ColumnChanging += new DataColumnChangeEventHandler(OsobaTable_ColumnChanging);
            OsobaTable.ColumnChanged += new DataColumnChangeEventHandler(OsobaTable_ColumnChanged);
            OsobaTable.TableNewRow += new DataTableNewRowEventHandler(OsobaTable_TableNewRow);
            OsobaTable.RowDeleting += new DataRowChangeEventHandler(OsobaTable_RowDeleting);
            OsobaTable.RowDeleted += new DataRowChangeEventHandler(OsobaTable_RowDeleted);
            OsobaTable.RowChanging += new DataRowChangeEventHandler(OsobaTable_RowChanging);
            OsobaTable.RowChanged += new DataRowChangeEventHandler(OsobaTable_RowChanged);

            return OsobaTable;
        }

        void OsobaTable_RowChanged(object sender, DataRowChangeEventArgs e)
        {
            lstMessages.Items.Add(string.Format("Changed row {0}", e.Row["ID"])); ;
        }

        void OsobaTable_RowChanging(object sender, DataRowChangeEventArgs e)
        {
            lstMessages.Items.Add(string.Format("Changing row {0}", e.Row["ID"])); ;
        }

        void OsobaTable_RowDeleted(object sender, DataRowChangeEventArgs e)
        {
            lstMessages.Items.Add(string.Format("Deleted row"));
        }

        void OsobaTable_RowDeleting(object sender, DataRowChangeEventArgs e)
        {
            lstMessages.Items.Add(string.Format("Deleting row {0}", e.Row["ID"]));
        }

        void OsobaTable_TableNewRow(object sender, DataTableNewRowEventArgs e)
        {
            lstMessages.Items.Add(string.Format("New row"));
        }

        void OsobaTable_ColumnChanged(object sender, DataColumnChangeEventArgs e)
        {
            lstMessages.Items.Add(string.Format("Cell {0} changed to {1}", e.Column, e.ProposedValue));
        }

        void OsobaTable_ColumnChanging(object sender, DataColumnChangeEventArgs e)
        {
            lstMessages.Items.Add(string.Format("Cell {0} changing to {1}", e.Column, e.ProposedValue));
        }

        private void btnClearMessages_Click(object sender, EventArgs e)
        {
            lstMessages.Items.Clear();
        }
    }
}