using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;

namespace MappingsExample
{
    class Program
    {
        private static string connectionString = "Data Source=.; Initial Catalog=Test; Integrated Security=true";
        private static string query = "SELECT ID AS 'User ID', ID_Jednostka as 'Unit', Imie as 'First Name', Nazwisko as 'Last Name', Pensja as 'Salary' FROM Osoba";

        public static DataSet GetData1(string dataSetName, string connectionString, string query)
        {
            DataSet dataSet = new DataSet(dataSetName);

            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                SqlDataAdapter adapter = new SqlDataAdapter(query, connection);

                DataTableMapping mapping = adapter.TableMappings.Add("Table", "Osoba");
                mapping.ColumnMappings.Add("User ID", "Id");
                mapping.ColumnMappings.Add("Unit", "Jednostka");
                mapping.ColumnMappings.Add("First Name", "Imi");
                mapping.ColumnMappings.Add("Last Name", "Nazwisko");
                mapping.ColumnMappings.Add("Salary", "Pensja");

                connection.Open();

                adapter.FillSchema(dataSet, SchemaType.Source);
                adapter.Fill(dataSet);

                return dataSet;
            }
        }


        public static DataSet GetData2(string dataSetName, string connectionString, string query)
        {
            using (SqlConnection connection = new SqlConnection(connectionString))
            {
                SqlDataAdapter da = new SqlDataAdapter(query, connection);

                DataTableMapping dtm = new DataTableMapping("Osoba", "Tabela Osoba", new DataColumnMapping[] {
                    new DataColumnMapping("User ID", "ID"),
                    new DataColumnMapping("Unit", "Jednostka"),
                    new DataColumnMapping("First Name", "Imi"),
                    new DataColumnMapping("Last Name", "Nazwisko"),
                    new DataColumnMapping("Salary", "Pensja")
                });

                DataSet ds = new DataSet();
                da.TableMappings.Add(dtm);
                da.FillSchema(ds, SchemaType.Mapped, "Osoba"); // Za drugim razem dajemy SchemaType.Source
                da.Fill(ds, "Osoba");

                return ds;
            }
        }

        private static void PrintTableSchema(DataTable t)
        {
            Console.WriteLine("Tabela: " + t.TableName);
            foreach (DataColumn c in t.Columns)
            {
                Console.WriteLine(string.Format(
                    "Name: {0}\t Type: {1}\t MaxLen: {2}\t AllowNulls?: {3}",
                    c.ColumnName, c.DataType, c.MaxLength, c.AllowDBNull));
            }
        }

        static void Main(string[] args)
        {
            PrintTableSchema(GetData1("Osoby", connectionString, query).Tables[0]);
            Console.ReadLine();
            PrintTableSchema(GetData2("Osoby", connectionString, query).Tables[0]);
            Console.ReadLine();

        }
    }
}
