/* Przygotowanie bazy danych

drop table Osoba;

create table Osoba(
  ID int not null primary key,
  Imie varchar(30) default 'Jan',
  Nazwisko varchar(50) default 'Kowalski',
);

begin
  delete from Osoba;
  insert into Osoba values( 1, 'Jan', 'Kowalski' );
  insert into Osoba values( 2, 'Ewa', 'Solska' );
  insert into Osoba values( 3, 'Boydar', 'Nowak' );
  insert into Osoba values( 4, 'Adam', 'Adamski' );
  insert into Osoba values( 5, 'Zygmunt', 'Riposta' );
  insert into Osoba values( 6, 'Alicja', 'Gleba' );
  insert into Osoba values( 7, 'Tania', 'Borwka' );
  insert into Osoba values( 8, 'Natasza', 'Lizacka' );
  insert into Osoba values( 9, 'Stan', 'Taczkowski' );
end;

*/

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;

namespace TransactionsDataSet
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection connection = new SqlConnection("Data Source=.; Initial Catalog=Test; Integrated Security=true;");
            SqlConnection connection2 = new SqlConnection("Data Source=.; Initial Catalog=Test; Integrated Security=true;");

            SqlDataAdapter da = new SqlDataAdapter();

            da.SelectCommand = new SqlCommand("SELECT ID, Imie, Nazwisko FROM Osoba", connection);
            da.InsertCommand = new SqlCommand("INSERT INTO Osoba (ID, Imie, Nazwisko ) VALUES(@ID, @Imie, @Nazwisko)", connection);
            da.UpdateCommand = new SqlCommand("UPDATE Osoba SET ID=@ID, Imie=@Imie, Nazwisko=@Nazwisko WHERE ID=@ID_prev", connection2);
            da.DeleteCommand = new SqlCommand("DELETE FROM Osoba WHERE ID=@ID", connection);

            da.InsertCommand.Parameters.Add("@ID", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Original;
            da.InsertCommand.Parameters.Add("@Imie", SqlDbType.VarChar, 30, "Imie").SourceVersion = DataRowVersion.Original;
            da.InsertCommand.Parameters.Add("@Nazwisko", SqlDbType.VarChar, 50, "Nazwisko").SourceVersion = DataRowVersion.Original;

            da.UpdateCommand.Parameters.Add("@ID", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Current;
            da.UpdateCommand.Parameters.Add("@Imie", SqlDbType.VarChar, 30, "Imie").SourceVersion = DataRowVersion.Current;
            da.UpdateCommand.Parameters.Add("@Nazwisko", SqlDbType.VarChar, 50, "Nazwisko").SourceVersion = DataRowVersion.Current;
            da.UpdateCommand.Parameters.Add("@ID_Prev", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Original;

            da.DeleteCommand.Parameters.Add("@ID", SqlDbType.Int, 0, "ID").SourceVersion = DataRowVersion.Current;

            DataTable dt = new DataTable("Osoba");
            da.Fill(dt);

            dt.Rows[0].BeginEdit();
            dt.Rows[0]["Imie"] = "Kunegunda";
            dt.Rows[0]["Nazwisko"] = "Zatorska";
            dt.Rows[0].EndEdit();

            DataRow newRow = dt.NewRow();
            newRow["ID"] = 100;
            newRow["Imie"] = "Johnny";
            newRow["Nazwisko"] = "Szpinak";
            dt.Rows.Add(newRow);

            DataTable dtChanges = dt.GetChanges();

            connection.Open();
            connection2.Open();
            SqlTransaction transaction = connection.BeginTransaction();
            SqlTransaction transaction2 = connection2.BeginTransaction();
            da.InsertCommand.Transaction = transaction2;
            da.UpdateCommand.Transaction = transaction;
            da.DeleteCommand.Transaction = transaction;

            try
            {
                if (dtChanges != null)
                {
                    da.Update(dtChanges);
                    dt.AcceptChanges();
                    transaction.Commit();
                    transaction2.Commit();
                }
                Console.WriteLine("OK");
            }
            catch (SqlException e)
            {
                //transaction.Commit();
                //transaction2.Commit();
                Console.WriteLine("AWARIA");
                transaction.Rollback();
                transaction2.Rollback();
                Console.WriteLine(e.Message);
            }
            finally
            {
                connection.Close();
            }
            Console.ReadLine();

        }
    }
}
